﻿using System;

namespace i388
{
    /// <summary>
    /// Reprezentál egy égtáj irányába történő forgatást a derékszögű forgatások számával.
    /// </summary>
    public class Forgatás
    {
        /// <summary>
        /// A derékszögű forgatások száma.
        /// </summary>
        public int Szám
        {
            get
            {
                return szám;
            }
            set
            {
                szám = value % 4;
            }
        }

        private int szám = 0;

        /// <summary>
        /// Létrehoz egy forgatást a derékszögű forgatások száma alapján.
        /// </summary>
        /// <param name="szám">A forgatások száma.</param>
        public Forgatás(int szám)
        {
            this.Szám = szám;
        }

        public static Forgatás operator-(Forgatás forgatás)
        {
            return new Forgatás(4 - forgatás.Szám);
        }

        /// <summary>
        /// Létrehoz egy forgatást egy irányból a másikba történő forgatással.
        /// </summary>
        /// <param name="irány1">Az első irány.</param>
        /// <param name="irány2">A második irány.</param>
        public Forgatás(Vektor2 irány1, Vektor2 irány2)
        {
            Vektor2 vektor = new Vektor2(irány1.X, irány1.Y);

            for (int i = 1; i <= 4; i++)
            {
                if (irány1.Forgatás(new Forgatás(i)) == irány2)
                {
                    this.Szám = i;
                    return;
                }
            }

            throw new InvalidOperationException();
        }
    }
}
